# Copyright 2020 StrongDM Inc
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: role_grants.proto for package 'v1'

require "grpc"
require "role_grants_pb"

module V1
  module RoleGrants
    # RoleGrants represent relationships between composite roles and the roles
    # that make up those composite roles. When a composite role is attached to another
    # role, the permissions granted to members of the composite role are augmented to
    # include the permissions granted to members of the attached role.
    class Service
      include GRPC::GenericService

      self.marshal_class_method = :encode
      self.unmarshal_class_method = :decode
      self.service_name = "v1.RoleGrants"

      # Create registers a new RoleGrant.
      rpc :Create, ::V1::RoleGrantCreateRequest, ::V1::RoleGrantCreateResponse
      # Get reads one RoleGrant by ID.
      rpc :Get, ::V1::RoleGrantGetRequest, ::V1::RoleGrantGetResponse
      # Delete removes a RoleGrant by ID.
      rpc :Delete, ::V1::RoleGrantDeleteRequest, ::V1::RoleGrantDeleteResponse
      # List gets a list of RoleGrants matching a given set of criteria.
      rpc :List, ::V1::RoleGrantListRequest, ::V1::RoleGrantListResponse
    end

    Stub = Service.rpc_stub_class
  end
end
